export const parseFilename = (titleToFilename: string): string => {
  if (!titleToFilename) {
    return 'None yet.'
  }

  titleToFilename = titleToFilename.replace(/[^a-zA-Z0-9_]+/gi, '-').toLowerCase();

  while (titleToFilename.endsWith('-')) {
    titleToFilename = titleToFilename.slice(0, -1);
  }

  if (titleToFilename.length > 50) { // Limit filename size
    titleToFilename = titleToFilename.substring(0, 50);

    if (titleToFilename.includes('-')) {
      titleToFilename = titleToFilename.substring(0, Math.min(titleToFilename.length, titleToFilename.lastIndexOf('-'))); // Re-trim to avoid cutting a word in half.
    }
  }

  return titleToFilename + '.json';
}

export const downloadFile = (postObj: any, fileName: string, archiveFile?: boolean): void => {
  const blob = new Blob([JSON.stringify(postObj, null, 2)], { type: 'text/plain;charset=utf-8;' });
  const a = document.createElement('a');
  a.setAttribute('download', archiveFile ? 'archive.json' : fileName);
  a.setAttribute('href', window.URL.createObjectURL(blob));
  a.click();
}